' ########################################################################################
' Mini-browser example.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "OLECON.INC"     ' // Ole Container
#INCLUDE ONCE "EXDISP.INC"     ' // WebBrowser Control
#INCLUDE ONCE "COMMCTRL.INC"   ' // Common controls
#INCLUDE ONCE "SHOBJIDL.INC"   ' // Shell objects
#RESOURCE "MiniBrowser.pbr"    ' // Resource file

' ========================================================================================
' Identifiers
' ========================================================================================

%IDC_STATUSBAR    = 101
%IDC_REBAR        = 102
%IDC_IEWB         = 103
%IDC_TOOLBAR      = 104
%IDC_EDITURL      = 105
%IDC_GOBTN        = 106

' Rebar1
%IDS_STRING0      = 32770
%IDS_STRING1      = 32771
%IDS_STRING2      = 32772

' Command
%IDM_GOBACK       = 28000
%IDM_GOFORWARD    = 28001
%IDM_FIND         = 28002
%IDM_PRINTPREVIEW = 28003
%IDM_PRINT        = 28004
%IDM_PROPERTIES   = 28005
%IDM_FILE_SAVE    = 28006
%IDM_PAGESETUP    = 28007
%IDM_EXIT         = 28008

' Image list
%IDI_INTERNET32   = 100
%IDI_INTERNET     = 101
%IDI_BACK         = 102
%IDI_FORWARD      = 103
%IDI_FIND         = 104
%IDI_PRINTPREV    = 105
%IDI_PAGESETUP    = 106
%IDI_PRINT        = 107
%IDI_PROPERTIES   = 108
%IDI_SAVE         = 109
%IDI_EXIT         = 110


' ========================================================================================
' Main
' ========================================================================================
FUNCTION WinMain ( _
   BYVAL hInstance     AS DWORD, _       ' handle of current instance
   BYVAL hPrevInstance AS DWORD, _       ' handle of previous instance(not used in Win32)
   BYVAL pszCmdLine    AS ASCIIZ PTR, _  ' address of command line
   BYVAL nCmdShow      AS LONG _         ' show state of window
   ) AS LONG

   LOCAL szClassName AS ASCIIZ * %MAX_PATH       ' class name
   LOCAL wcex        AS WNDCLASSEX               ' class information
   LOCAL ticc        AS INIT_COMMON_CONTROLSEX   ' specifies common control classes to register
   LOCAL hWndMain    AS DWORD
   LOCAL cxIcon      AS LONG                     ' width of a small icon in pixels
   LOCAL cyIcon      AS LONG                     ' height of a small icon in pixels

   ' Initilize the COM library using OleInitialize to allow cut and paste
   OleInitialize 0

   ' Required: Initialize the Ole Container
   OC_WinInit

   ' Register the Form1 window
   szClassName        = "MiniBrowser"
   wcex.cbSize        = SIZEOF(wcex)                                ' size of WNDCLASSEX structure
   wcex.style         = %CS_DBLCLKS                                 ' class styles
   wcex.lpfnWndProc   = CODEPTR(WndProc)                            ' address of window procedure used by class
   wcex.cbClsExtra    = 0                                           ' extra class bytes
   wcex.cbWndExtra    = 0                                           ' extra window bytes
   wcex.hInstance     = hInstance                                   ' instance of the process that is registering the window
   wcex.hIcon         = LoadIcon(hInstance, BYVAL %IDI_INTERNET32) ' handle of class icon
   wcex.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)         ' handle of class cursor
   wcex.hbrBackground = %COLOR_BTNFACE + 1                          ' brush used to fill background of window's client area
   wcex.lpszMenuName  = %NULL                                       ' resource identifier of the class menu
   wcex.lpszClassName = VARPTR(szClassName)                         ' class name
   wcex.hIconSm       = LoadImage(hInstance, BYVAL %IDI_INTERNET, %IMAGE_ICON, cxIcon, cyIcon, %LR_DEFAULTCOLOR)  ' handle of small icon shown in caption/system Taskbar

   IF ISFALSE RegisterClassEx(wcex) THEN EXIT FUNCTION

   ' Load the common controls library and specify the classes to register.
   ticc.dwSize = SIZEOF(ticc)
   ticc.dwICC  = %ICC_BAR_CLASSES OR %ICC_COOL_CLASSES
   InitCommonControlsEx ticc

   ' Create the Form1 window
   hWndMain = CreateWindowEx(%WS_EX_WINDOWEDGE, _                                          ' extended styles
                             "MiniBrowser", _                                              ' class name
                             "Mini WebBrowser", _                                       ' caption
                             %WS_OVERLAPPEDWINDOW OR %WS_VISIBLE, _                        ' window styles
                             0, 0, _                                                       ' left, top
                             800, 568, _                                                       ' width, height
                             %NULL, %NULL, _                                               ' handle of owner, menu handle
                             hInstance, BYVAL %NULL)                                      ' handle of instance, creation parameters
   IF ISFALSE hWndMain THEN EXIT FUNCTION

   ' Make the window visible; update its client area
   ShowWindow hWndMain, nCmdShow
   UpdateWindow hWndMain

   ' Message handler loop
   LOCAL uMsg AS tagMsg
   WHILE GetMessage(uMsg, %NULL, 0, 0)
      IF ISFALSE OC_ForwardMessage(GetFocus, uMsg) THEN
         IF IsDialogMessage(hWndMain, uMsg) = 0 THEN
            TranslateMessage uMsg
            DispatchMessage uMsg
         END IF
      END IF
   WEND

   ' Uninitialize the COM library
   OleUninitialize

   FUNCTION = uMsg.wParam

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main Window procedure
' ========================================================================================
FUNCTION WndProc ( _
   BYVAL hWnd    AS DWORD, _ ' window handle
   BYVAL uMsg    AS DWORD, _ ' type of message
   BYVAL wParam  AS DWORD, _ ' first message parameter
   BYVAL lParam  AS LONG _   ' second message parameter
   ) AS LONG

   LOCAL szItem        AS ASCIIZ * %MAX_PATH   ' working variable
   LOCAL trbi          AS REBARINFO            ' specifies attributes(imagelist) of the rebar control
   LOCAL trbbi         AS REBARBANDINFO        ' specifies or receives the attributes of a rebar band
   LOCAL ttbb          AS TBBUTTON             ' specifies or receives the attributes of a toolbar button
   LOCAL ttbab         AS TBADDBITMAP          ' specifies the images to add to a toolbar
   LOCAL ptnmhdr       AS NMHDR PTR            ' information about a notification message
   LOCAL ptttdi        AS NMTTDISPINFO PTR     ' tooltip notification message information
   LOCAL pttbb         AS TBBUTTON PTR         ' address of array of toolbar button info
   LOCAL plEdge        AS LONG PTR             ' address of array of right edges
   LOCAL hCtrl         AS DWORD                ' handle of child window
   LOCAL hWndRebar     AS DWORD                ' handle of rebar control
   LOCAL hFont         AS DWORD                ' handle of font used by form
   LOCAL hImage        AS DWORD                ' handle of the image
   LOCAL hImageList    AS DWORD                ' handle of the image list

   LOCAL pIWebBrowser2 AS IWebBrowser2
   LOCAL vUrl          AS VARIANT
   LOCAL szUrl         AS ASCIIZ * 2048        ' %INTERNET_MAX_PATH_LENGTH
   STATIC pWBEvents    AS DWebBrowserEvents2Impl

   SELECT CASE uMsg

      CASE %WM_SYSCOMMAND
         ' Capture this message and send a WM_CLOSE message
         IF (wParam AND &HFFF0) = %SC_CLOSE THEN
            SendMessage hWnd, %WM_CLOSE, 0, 0
            EXIT FUNCTION
         END IF

      CASE %WM_COMMAND

         SELECT CASE LO(WORD, wParam)

            CASE %IDOK
               ' If we are in the URL edit control, load the web page
               hCtrl = GetDlgItem(GetDlgItem(hWnd, %IDC_REBAR), %IDC_EDITURL)
               IF GetFocus = hCtrl THEN
                  PostMessage hWnd, %WM_COMMAND, %IDC_GOBTN, MAK(DWORD, %BN_CLICKED, %IDC_GOBTN)
                  EXIT FUNCTION
               END IF

            CASE %IDM_EXIT
               SendMessage hWnd, %WM_CLOSE, 0, 0
               EXIT FUNCTION

            CASE %IDC_GOBTN
               IF HI(WORD, wParam) = %BN_CLICKED THEN
                  ' Get the Url
                  hCtrl = GetDlgItem(GetDlgItem(hWnd, %IDC_REBAR), %IDC_EDITURL)
                  GetWindowText hCtrl, szUrl, SIZEOF(szUrl)
                  vUrl = szUrl
                  pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
                  IF ISOBJECT(pIWebBrowser2) THEN
                     pIWebBrowser2.Navigate2 vUrl
                     pIWebBrowser2 = NOTHING
                  END IF
                  EXIT FUNCTION
               END IF

            CASE %IDM_GOBACK
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  pIWebBrowser2.GoBack
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDM_GOFORWARD
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  pIWebBrowser2.GoForward
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDM_FIND
              ' Warning: This code uses an undocumented command-group GUID that is
              ' subject to change in the future. Currently it works in all versions of
              ' Internet Explorer up to 7. See http://support.microsoft.com/?kbid=311288
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  LOCAL CGID_WebBrowser AS GUID
                  LOCAL pDisp AS IDispatch
                  LOCAL pCmdTarget AS IOleCommandTarget
                  LOCAL vIn AS VARIANT
                  LOCAL vOut AS VARIANT
                  CGID_WebBrowser = GUID$("{ED016940-BD5B-11CF-BA4E-00C04FD70816}")
                  pDisp = pIWebBrowser2.Document
                  IF ISOBJECT(pDisp) THEN
                     pCmdTarget = pDisp
                     IF ISOBJECT(pCmdTarget) THEN
                        pCmdTarget.Exec(CGID_WebBrowser, 1, 0, vIn, vOut)
                     END IF
                  END IF
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDM_PRINTPREVIEW
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  pIWebBrowser2.ExecWB %OLECMDID_PRINTPREVIEW, %OLECMDEXECOPT_PROMPTUSER
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDM_PAGESETUP
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  pIWebBrowser2.ExecWB %OLECMDID_PAGESETUP, %OLECMDEXECOPT_PROMPTUSER
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDM_PRINT
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  pIWebBrowser2.ExecWB %OLECMDID_PRINT, %OLECMDEXECOPT_PROMPTUSER
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDM_PROPERTIES
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  pIWebBrowser2.ExecWB %OLECMDID_PROPERTIES, %OLECMDEXECOPT_PROMPTUSER
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDM_FILE_SAVE
               pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %IDC_IEWB))
               IF ISOBJECT(pIWebBrowser2) THEN
                  pIWebBrowser2.ExecWB %OLECMDID_SAVEAS, %OLECMDEXECOPT_PROMPTUSER
                  pIWebBrowser2 = NOTHING
               END IF
               EXIT FUNCTION

            CASE %IDC_EDITURL
               SELECT CASE HI(WORD, wParam)
                  CASE %EN_SETFOCUS
                     ' Select all the text of the edit box
                     PostMessage lParam, %EM_SETSEL, 0, -1
                     EXIT FUNCTION
               END SELECT

         END SELECT

      CASE %WM_NOTIFY
         ptnmhdr = lParam

         SELECT CASE @ptnmhdr.code
            CASE %TTN_GETDISPINFO
               ptttdi        = lParam
               @ptttdi.hinst = %NULL

               SELECT CASE @ptttdi.hdr.hwndFrom
                  hCtrl = GetDlgItem(GetDlgItem(hWnd, %IDC_REBAR), %IDC_TOOLBAR)
                  CASE SendMessage(hCtrl, %TB_GETTOOLTIPS, 0, 0)
                     SELECT CASE @ptttdi.hdr.idFrom
                        CASE %IDM_GOBACK
                           szItem = "Go Back"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_GOFORWARD
                           szItem = "Go Forward"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_FIND
                           szItem = "Find"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_PRINTPREVIEW
                           szItem = "Print Preview"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_PAGESETUP
                           szItem = "Page Setup"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_PRINT
                           szItem = "Print"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_PROPERTIES
                           szItem = "Properties"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_FILE_SAVE
                           szItem = "Save As"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                        CASE %IDM_EXIT
                           szItem = "Exit"
                           @ptttdi.lpszText = VARPTR(szItem)
                           EXIT FUNCTION
                     END SELECT
               END SELECT

         END SELECT

      CASE %WM_SYSCOLORCHANGE
         ' Forward this message to common controls so that they will
         ' be properly updated when the user changes the color settings.
         SendMessage GetDlgItem(hWnd, %IDC_STATUSBAR), %WM_SYSCOLORCHANGE, wParam, lParam
         hWndRebar = GetDlgItem(hWnd, %IDC_REBAR)
         SendMessage hWndRebar, %WM_SYSCOLORCHANGE, wParam, lParam
         SendMessage GetDlgItem(hWndRebar, %IDC_TOOLBAR), %WM_SYSCOLORCHANGE, wParam, lParam

      CASE %WM_SETFOCUS
         ' Set the keyboard focus to the first control that is
         ' visible, not disabled, and has the WS_TABSTOP style
         SetFocus GetNextDlgTabItem(hWnd, %NULL, %FALSE)
         EXIT FUNCTION

      CASE %WM_DESTROY
         ' Disconnect events
         IF ISOBJECT(pWBEvents) THEN EVENTS END pWBEvents
         ' Destroy the image list used by the toolbar
         hCtrl = GetDlgItem(GetDlgItem(hWnd, %IDC_REBAR), %IDC_TOOLBAR)
         ImageList_Destroy SendMessage(hCtrl, %TB_SETIMAGELIST, 0, %NULL)
         ' Quit the application
         PostQuitMessage 0
         EXIT FUNCTION

      CASE %WM_SIZE
         IF wParam <> %SIZE_MINIMIZED THEN
            LOCAL rc AS RECT
            LOCAL rbh AS LONG
            LOCAL sbh AS LONG
            SendMessage GetDlgItem(hWnd, %IDC_STATUSBAR), %WM_SIZE, wParam, lParam
            InvalidateRect GetDlgItem(hWnd, %IDC_STATUSBAR), BYVAL %NULL, %TRUE
            SendMessage GetDlgItem(hWnd, %IDC_REBAR), %WM_SIZE, wParam, lParam
            ' Height of the rebar
            GetClientRect GetDlgItem(hWnd, %IDC_REBAR), rc
            rbh = rc.nBottom - rc.nTop
            ' Height of the statusbar
            GetClientRect GetDlgItem(hWnd, %IDC_STATUSBAR), rc
            sbh = rc.nBottom - rc.nTop
            MoveWindow GetDlgItem(hWnd, %IDC_IEWB), 0, rbh + 1, LO(WORD, lParam), HI(WORD, lParam) - rbh - sbh, %TRUE
            EXIT FUNCTION
         END IF

      CASE %WM_CREATE
         ' Create font used by container
         hFont = GetStockObject(%DEFAULT_GUI_FONT)

         ' Create the Statusbar statusbar control
         hCtrl = CreateWindowEx(%NULL, _                                             ' extended styles
                                    "msctls_statusbar32", _                              ' class name
                                    "", _                                                ' caption
                                    %WS_CHILD OR %WS_VISIBLE OR _                        ' window styles
                                    %CCS_BOTTOM OR %SBARS_SIZEGRIP, _                    ' class styles
                                    0, 347, _                                            ' left, top
                                    535, 23, _                                           ' width, height
                                    hWnd, %IDC_STATUSBAR, _                       ' handle of parent, control ID
                                    GetModuleHandle(""), BYVAL %NULL)                    ' handle of instance, creation parameters
         SendMessage hCtrl, %WM_SETFONT, hFont, %TRUE

         ' Allocate memory for the coordinate of the right edge of each part
         plEdge = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, 1 * 4)
         IF plEdge THEN
            @plEdge[0] = -1
            SendMessage hCtrl, %SB_SETPARTS, 1, BYVAL plEdge
            ' Free memory that was allocated for the edge info
            HeapFree GetProcessHeap(), 0, BYVAL plEdge
         END IF
         ' Update the size of the statusbar
         SendMessage hCtrl, %WM_SIZE, 0, 0

         ' Create the WebBrowser control
         hCtrl = CreateWindowEx(%NULL, _                                                 ' extended styles
                                    $OC_CLASSNAME, _                                     ' class name
                                    "Shell.Explorer", _                                  ' caption
                                    %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                    %WS_TABSTOP, _
                                    0, 0, _                                              ' left, top
                                    0, 0, _                                              ' width, height
                                    hWnd, %IDC_IEWB, _                                   ' handle of parent, control ID
                                    GetModuleHandle(""), BYVAL %NULL)                    ' handle of instance, creation parameters

         ' Create the Rebar rebar control
         hCtrl = CreateWindowEx(%NULL, _                                             ' extended styles
                                    "ReBarWindow32", _                                   ' class name
                                    "", _                                                ' caption
                                    %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER OR _          ' window styles
                                    %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS OR _
                                    %CCS_NOPARENTALIGN OR %CCS_NODIVIDER OR _            ' class styles
                                    %RBS_VARHEIGHT OR %RBS_BANDBORDERS, _
                                    0, 0, _                                              ' left, top
                                    790, 30, _                                           ' width, height
                                    hWnd, %IDC_REBAR, _                           ' handle of parent, control ID
                                    GetModuleHandle(""), BYVAL %NULL)                    ' handle of instance, creation parameters
         ' Save the handle of the rebar.  It is used when embedding controls
         hWndRebar = hCtrl
         SendMessage hCtrl, %WM_SETFONT, hFont, %TRUE

         ' Create the Toolbar toolbar control
         hCtrl = CreateWindowEx(%NULL, _                                             ' extended styles
                                    "ToolbarWindow32", _                                 ' class name
                                    "", _                                                ' caption
                                    %WS_CHILD OR %WS_VISIBLE OR _                        ' window styles
                                    %CCS_NORESIZE OR %CCS_NODIVIDER OR _                 ' class styles
                                    %TBSTYLE_TOOLTIPS OR %TBSTYLE_FLAT, _
                                    0, 4, _                                              ' left, top
                                    204, 21, _                                           ' width, height
                                    hWnd, %IDC_TOOLBAR, _                         ' handle of parent, control ID
                                    GetModuleHandle(""), BYVAL %NULL)                    ' handle of instance, creation parameters
         SendMessage hCtrl, %WM_SETFONT, hFont, %TRUE

         ' Create and initialize the image list
         hImageList = ImageList_Create(16, 16, %ILC_MASK OR %ILC_COLOR24, 9, 0)
         IF hImageList THEN
            ' Set the background color to use for drawing images
            ImageList_SetBkColor hImageList, %CLR_NONE
            ' Add the images to the imagelist
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_BACK, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_FORWARD, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_FIND, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_PRINTPREV, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_PAGESETUP, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_PRINT, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_PROPERTIES, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_SAVE, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
            hImage = LoadImage(GetModuleHandle(""), BYVAL %IDI_EXIT, %IMAGE_ICON, 16, 16, %LR_DEFAULTCOLOR)
            ImageList_ReplaceIcon hImageList, -1, hImage
            DeleteObject hImage
         END IF

         ' Set the imagelist used with default images
         SendMessage hCtrl, %TB_SETIMAGELIST, 0, hImageList

         ' Allocate memory for the button info array
         pttbb = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, 9 * SIZEOF(ttbb))
         IF pttbb THEN
           ' Send the TB_BUTTONSTRUCTSIZE message, for backward compatibility
           SendMessage hCtrl, %TB_BUTTONSTRUCTSIZE, SIZEOF(ttbb), 0
            ' Set the size of the bitmaps
            SendMessage hCtrl, %TB_SETBITMAPSIZE, 0, MAKLNG(16, 16)
           ' Add buttons to the toolbar
           @pttbb[0].iBitmap   = 0
           @pttbb[0].idCommand = %IDM_GOBACK
           @pttbb[0].fsState   = %TBSTATE_ENABLED
           @pttbb[0].fsStyle   = %BTNS_BUTTON
           @pttbb[0].dwData    = 0
           @pttbb[0].iString   = -1

           @pttbb[1].iBitmap   = 1
           @pttbb[1].idCommand = %IDM_GOFORWARD
           @pttbb[1].fsState   = %TBSTATE_ENABLED
           @pttbb[1].fsStyle   = %BTNS_BUTTON
           @pttbb[1].dwData    = 0
           @pttbb[1].iString   = -1

           @pttbb[2].iBitmap   = 2
           @pttbb[2].idCommand = %IDM_FIND
           @pttbb[2].fsState   = %TBSTATE_ENABLED
           @pttbb[2].fsStyle   = %BTNS_BUTTON
           @pttbb[2].dwData    = 0
           @pttbb[2].iString   = -1

           @pttbb[3].iBitmap   = 3
           @pttbb[3].idCommand = %IDM_PRINTPREVIEW
           @pttbb[3].fsState   = %TBSTATE_ENABLED
           @pttbb[3].fsStyle   = %BTNS_BUTTON
           @pttbb[3].dwData    = 0
           @pttbb[3].iString   = -1

           @pttbb[4].iBitmap   = 4
           @pttbb[4].idCommand = %IDM_PAGESETUP
           @pttbb[4].fsState   = %TBSTATE_ENABLED
           @pttbb[4].fsStyle   = %BTNS_BUTTON
           @pttbb[4].dwData    = 0
           @pttbb[4].iString   = -1

           @pttbb[5].iBitmap   = 5
           @pttbb[5].idCommand = %IDM_PRINT
           @pttbb[5].fsState   = %TBSTATE_ENABLED
           @pttbb[5].fsStyle   = %BTNS_BUTTON
           @pttbb[5].dwData    = 0
           @pttbb[5].iString   = -1

           @pttbb[6].iBitmap   = 6
           @pttbb[6].idCommand = %IDM_PROPERTIES
           @pttbb[6].fsState   = %TBSTATE_ENABLED
           @pttbb[6].fsStyle   = %BTNS_BUTTON
           @pttbb[6].dwData    = 0
           @pttbb[6].iString   = -1

           @pttbb[7].iBitmap   = 7
           @pttbb[7].idCommand = %IDM_FILE_SAVE
           @pttbb[7].fsState   = %TBSTATE_ENABLED
           @pttbb[7].fsStyle   = %BTNS_BUTTON
           @pttbb[7].dwData    = 0
           @pttbb[7].iString   = -1

           @pttbb[8].iBitmap   = 8
           @pttbb[8].idCommand = %IDM_EXIT
           @pttbb[8].fsState   = %TBSTATE_ENABLED
           @pttbb[8].fsStyle   = %BTNS_BUTTON
           @pttbb[8].dwData    = 0
           @pttbb[8].iString   = -1

           SendMessage hCtrl, %TB_ADDBUTTONS, 9, BYVAL pttbb
           ' Free memory that was allocated for the button info
           HeapFree GetProcessHeap(), 0, BYVAL pttbb
           ' Update the size of the toolbar
           SendMessage hCtrl, %TB_AUTOSIZE, 0, 0
         END IF

         ' Add the band containing the Toolbar1 toolbar control to the rebar
         trbbi.cbSize     = SIZEOF(trbbi)
         trbbi.fMask      = %RBBIM_STYLE OR %RBBIM_CHILD OR %RBBIM_CHILDSIZE OR _
                            %RBBIM_SIZE OR %RBBIM_ID OR %RBBIM_IDEALSIZE
         trbbi.fStyle     = %RBBS_FIXEDSIZE OR %RBBS_CHILDEDGE
         trbbi.hWndChild  = hCtrl
         trbbi.cxMinChild = 110
         trbbi.cyMinChild = 21
         trbbi.cx         = 110
         trbbi.wID        = %IDS_STRING0
         trbbi.cxIdeal    = 110
         SendMessage hWndRebar, %RB_INSERTBAND, -1, BYVAL VARPTR(trbbi)

         ' Create the EditUrl edit control
         hCtrl = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                    "Edit", _                                            ' class name
                                    "", _                                                ' caption
                                    %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR _         ' window styles
                                    %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                    151, 4, _                                            ' left, top
                                    350, 21, _                                           ' width, height
                                    hWnd, %IDC_EDITURL, _                          ' handle of parent, control ID
                                    GetModuleHandle(""), BYVAL %NULL)                    ' handle of instance, creation parameters
         SendMessage hCtrl, %WM_SETFONT, hFont, %TRUE

         ' Add the band containing the EditUrl edit control to the rebar
         szItem           = "URL"
         trbbi.cbSize     = SIZEOF(trbbi)
         trbbi.fMask      = %RBBIM_STYLE OR %RBBIM_TEXT OR %RBBIM_CHILD OR _
                            %RBBIM_CHILDSIZE OR %RBBIM_SIZE OR %RBBIM_ID OR _
                            %RBBIM_IDEALSIZE
         trbbi.fStyle     = %RBBS_FIXEDSIZE OR %RBBS_CHILDEDGE
         trbbi.lpText     = VARPTR(szItem)
         trbbi.hWndChild  = hCtrl
         trbbi.cxMinChild = 350
         trbbi.cyMinChild = 21
         trbbi.cx         = 350
         trbbi.wID        = %IDS_STRING1
         trbbi.cxIdeal    = 350
         SendMessage hWndRebar, %RB_INSERTBAND, -1, BYVAL VARPTR(trbbi)

         ' Create the GoBtn text button
         hCtrl = CreateWindowEx(%NULL, _                                             ' extended styles
                                    "Button", _                                          ' class name
                                    "Go", _                                              ' caption
                                    %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR _         ' window styles
                                    %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER OR _     ' class styles
                                    %BS_FLAT, _
                                    493, 2, _                                            ' left, top
                                    34, 24, _                                            ' width, height
                                    hWnd, %IDC_GOBTN, _                            ' handle of parent, control ID
                                    GetModuleHandle(""), BYVAL %NULL)                    ' handle of instance, creation parameters
         SendMessage hCtrl, %WM_SETFONT, hFont, %TRUE

         ' Add the band containing the GoBtn text button to the rebar
         trbbi.cbSize     = SIZEOF(trbbi)
         trbbi.fMask      = %RBBIM_STYLE OR %RBBIM_CHILD OR %RBBIM_CHILDSIZE OR _
                            %RBBIM_SIZE OR %RBBIM_ID OR %RBBIM_IDEALSIZE
         trbbi.fStyle     = %RBBS_FIXEDSIZE OR %RBBS_CHILDEDGE
         trbbi.hWndChild  = hCtrl
         trbbi.cxMinChild = 34
         trbbi.cyMinChild = 24
         trbbi.cx         = 34
         trbbi.wID        = %IDS_STRING2
         trbbi.cxIdeal    = 34
         SendMessage hWndRebar, %RB_INSERTBAND, -1, BYVAL VARPTR(trbbi)

         ' Retrieve a reference to the WebBrowser control
         hCtrl = GetDlgItem(hWnd, %IDC_IEWB)
         pIWebBrowser2 = OC_GetDispatch(hCtrl)
         IF ISOBJECT(pIWebBrowser2) THEN
            ' Connect to the events fired by the control
            pWBEvents = CLASS "CDWebBrowserEvents2"
            EVENTS FROM pIWebBrowser2 CALL pWBEvents
            ' Navigate to a site
            vUrl = "http://www.jose.it-berater.org/index.html"
            pIWebBrowser2.Navigate2 vUrl
            pIWebBrowser2 = NOTHING
         END IF
         EXIT FUNCTION

   END SELECT

   FUNCTION = DefWindowProc(hWnd, uMsg, wParam, lParam)

END FUNCTION
' ========================================================================================

' ########################################################################################
' Class CDWebBrowserEvents2
' Interface name = DWebBrowserEvents2
' IID = {34A715A0-6587-11D0-924A-0020AFC7AC4D}
' Web Browser Control events interface
' Attributes = 4112 [&H1010] [Hidden] [Dispatchable]
' ########################################################################################

CLASS CDWebBrowserEvents2 GUID$("{700B73A2-CCFC-4FE0-B9AC-D5853D71B7B9}") AS EVENT

   INSTANCE pIWebBrowser2 AS IWebBrowser2
   INSTANCE bNewWindow3 AS LONG

INTERFACE DWebBrowserEvents2Impl GUID$("{34A715A0-6587-11D0-924A-0020AFC7AC4D}") AS EVENT

   INHERIT IDispatch

   ' =====================================================================================
   METHOD StatusTextChange <102> ( _
     BYVAL strText AS STRING _                          ' __in BSTR Text
   )                                                    ' void

      ' Retrieve the handle of the main window
      LOCAL hWnd AS DWORD
      hWnd = GetFocus
      WHILE ISTRUE (GetWindowLong(hWnd, %GWL_STYLE) AND %WS_CHILD)
         IF ISTRUE (GetWindowLong(hWnd, %GWL_EXSTYLE) AND %WS_EX_MDICHILD) THEN EXIT LOOP
         hWnd = GetParent(hWnd)
      WEND
      ' Retrieve the handle of teh status bar
      LOCAL hStatusBar AS DWORD
      hStatusBar = GetDlgItem(hWnd, %IDC_STATUSBAR)
      IF ISFALSE hStatusBar THEN EXIT METHOD
      ' Show the changed statusbar text
      strText = ACODE$(strText)
      SendMessage (hStatusBar, %SB_SETTEXT, 0, BYVAL STRPTR(strText))

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD ProgressChange <108> ( _
     BYVAL Progress AS LONG _                           ' __in long Progress
   , BYVAL ProgressMax AS LONG _                        ' __in long ProgressMax
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD CommandStateChange <105> ( _
     BYVAL nCommand AS LONG _                           ' __in long Command
   , BYVAL bEnable AS INTEGER _                         ' __in VARIANT_BOOL Enable
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD DownloadBegin <106>

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD DownloadComplete <104>

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD TitleChange <113> ( _
     BYVAL strText AS STRING _                          ' __in BSTR Text
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PropertyChange <112> ( _
     BYVAL strProperty AS STRING _                      ' __in BSTR szProperty
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD BeforeNavigate2 <250> ( _
     BYVAL pDisp AS IDispatch _                         ' __in IDispatch* pDisp
   , BYREF vURL AS VARIANT _                            ' __in VARIANT* URL
   , BYREF vFlags AS VARIANT _                          ' __in VARIANT* Flags
   , BYREF vTargetFrameName AS VARIANT _                ' __in VARIANT* TargetFrameName
   , BYREF vPostData AS VARIANT _                       ' __in VARIANT* PostData
   , BYREF vHeaders AS VARIANT _                        ' __in VARIANT* Headers
   , BYREF Cancel AS INTEGER _                          ' __in_out VARIANT_BOOL* Cancel
   )                                                    ' void

      ' Save a reference to the WebBrowser control
      IF ISNOTHING(pIWebBrowser2) THEN pIWebBrowser2 = pDisp

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NewWindow2 <251> ( _
     BYREF ppDisp AS IDispatch _                        ' __in_out IDispatch** ppDisp
   , BYREF bCancel AS INTEGER _                         ' __in_out VARIANT_BOOL* Cancel
   )                                                    ' void

      ' Cancel new window creation if the NewWindow3 event has been processed.
      IF bNewWindow3 THEN bCancel = %VARIANT_TRUE

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NavigateComplete2 <252> ( _
     BYVAL pDisp AS IDispatch _                         ' __in IDispatch* pDisp
   , BYREF vURL AS VARIANT _                            ' __in VARIANT* URL
   )                                                    ' void

      ' Retrieve the handle of the main window
      LOCAL hWnd AS DWORD
      hWnd = GetFocus
      WHILE ISTRUE (GetWindowLong(hWnd, %GWL_STYLE) AND %WS_CHILD)
         IF ISTRUE (GetWindowLong(hWnd, %GWL_EXSTYLE) AND %WS_EX_MDICHILD) THEN EXIT LOOP
         hWnd = GetParent(hWnd)
      WEND
      ' Retrieve the handle of teh status bar
      LOCAL hStatusBar AS DWORD
      hStatusBar = GetDlgItem(hWnd, %IDC_STATUSBAR)
      IF ISFALSE hStatusBar THEN EXIT METHOD
      ' Retrieve the handle of the rebar control
      LOCAL hCtrl AS DWORD
      hCtrl = GetDlgItem(hwnd, %IDC_REBAR)
      ' Retrieve the handle of the edit control
      hCtrl = GetDlgItem(hCtrl, %IDC_EDITURL)
      ' Show the canonicalized and qualified URL
      SetWindowText hCtrl, VARIANT$(vURL)
      ' Show the changed statusbar text
      LOCAL strURL AS STRING
      strURL = VARIANT$(vURL)
      SendMessage (hStatusBar, %SB_SETTEXT, 0, BYVAL STRPTR(strURL))

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD DocumentComplete <259> ( _
     BYVAL pDisp AS IDispatch _                         ' __in IDispatch* pDisp
   , BYREF vURL AS VARIANT _                            ' __in VARIANT* URL
   )                                                    ' void


   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OnQuit <253>

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OnVisible <254> ( _
     BYVAL bVisible AS INTEGER _                        ' __in VARIANT_BOOL Visible
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OnToolBar <255> ( _
     BYVAL bToolBar AS INTEGER _                        ' __in VARIANT_BOOL ToolBar
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OnMenuBar <256> ( _
     BYVAL bMenuBar AS INTEGER _                        ' __in VARIANT_BOOL MenuBar
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OnStatusBar <257> ( _
     BYVAL bStatusBar AS INTEGER _                      ' __in VARIANT_BOOL StatusBar
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OnFullScreen <258> ( _
     BYVAL bFullScreen AS INTEGER _                     ' __in VARIANT_BOOL FullScreen
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OnTheaterMode <260> ( _
     BYVAL bTheaterMode AS INTEGER _                    ' __in VARIANT_BOOL TheaterMode
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD WindowSetResizable <262> ( _
     BYVAL bResizable AS INTEGER _                      ' __in VARIANT_BOOL Resizable
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD WindowSetLeft <264> ( _
     BYVAL nLeft AS LONG _                              ' __in long Left
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD WindowSetTop <265> ( _
     BYVAL Top AS LONG _                                ' __in long Top
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD WindowSetWidth <266> ( _
     BYVAL nWidth AS LONG _                             ' __in long Width
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD WindowSetHeight <267> ( _
     BYVAL Height AS LONG _                             ' __in long Height
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD WindowClosing <263> ( _
     BYVAL IsChildWindow AS INTEGER _                   ' __in     VARIANT_BOOL IsChildWindow
   , BYREF bCancel AS INTEGER _                         ' __in_out VARIANT_BOOL* Cancel
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD ClientToHostWindow <268> ( _
     BYREF CX AS LONG _                                 ' __in_out long* CX
   , BYREF CY AS LONG _                                 ' __in_out long* CY
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD SetSecureLockIcon <269> ( _
     BYVAL SecureLockIcon AS LONG _                     ' __in long SecureLockIcon
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD FileDownload <270> ( _
     BYVAL bActiveDocument AS INTEGER _                 ' __in     VARIANT_BOOL ActiveDocument
   , BYREF bCancel AS INTEGER _                         ' __in_out VARIANT_BOOL* Cancel
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NavigateError <271> ( _
     BYVAL pDisp AS IDispatch _                         ' __in IDispatch* pDisp
   , BYREF vURL AS VARIANT _                            ' __in VARIANT* URL
   , BYREF vFrame AS VARIANT _                          ' __in VARIANT* Frame
   , BYREF vStatusCode AS VARIANT _                     ' __in VARIANT* StatusCode
   , BYREF bCancel AS INTEGER _                         ' __in_out VARIANT_BOOL* Cancel
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PrintTemplateInstantiation <225> ( _
     BYVAL pDisp AS IDispatch _                         ' __in IDispatch* pDisp
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PrintTemplateTeardown <226> ( _
     BYVAL pDisp AS IDispatch _                         ' __in pDisp /* VT_DISPATCH <IDispatch> */
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD UpdatePageStatus <227> ( _
     BYVAL pDisp AS IDispatch _                         ' __in IDispatch* pDisp
   , BYREF nPage AS VARIANT _                           ' __in VARIANT* nPage
   , BYREF fDone AS VARIANT _                           ' __in VARIANT* fDone
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PrivacyImpactedStateChange <272> ( _
     BYVAL bImpacted AS INTEGER _                       ' __in VARIANT_BOOL bImpacted
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NewWindow3 <273> ( _
     BYREF ppDisp AS IDispatch _                        ' __in_out IDispatch** ppDisp
   , BYREF bCancel AS INTEGER _                         ' __in_out VARIANT_BOOL* Cancel
   , BYVAL dwFlags AS DWORD _                           ' __in unsigned long dwFlags
   , BYVAL bstrUrlContext AS STRING _                   ' __in BSTR bstrUrlContext
   , BYVAL bstrUrl AS STRING _                          ' __in BSTR bstrUrl
   )                                                    ' void

      IF ISNOTHING(pIWebBrowser2) THEN EXIT METHOD
      ' Retrieve the handle of the main window
      LOCAL hWnd AS DWORD
      hWnd = GetFocus
      WHILE ISTRUE (GetWindowLong(hWnd, %GWL_STYLE) AND %WS_CHILD)
         IF ISTRUE (GetWindowLong(hWnd, %GWL_EXSTYLE) AND %WS_EX_MDICHILD) THEN EXIT LOOP
         hWnd = GetParent(hWnd)
      WEND
      ' Retrieve the handle of the window that hosts the webbrowser control
      LOCAL hCtrl AS DWORD
      hCtrl = GetDlgItem(hWnd, %IDC_IEWB)
      ' Cancel new window creation.
      bCancel = %VARIANT_TRUE
      LOCAL strUrl AS STRING
      LOCAL vURL AS VARIANT
      strUrl = ACODE$(bstrUrl)
      ' Bug: IE6 gives "?ttp://" instead of "http://"
      IF LEFT$(strURL, 1) <> "h" THEN MID$(strURL, 1, 1) = "h"
      ' The combination of the %NWMF_FIRST_USERINITED and %NWMF_USERINITED flags
      ' indicate that is the first query that results of a user-initiated action
      ' (a mouse click or key press). Otherwise, it must be a popup.
      IF (dwFlags AND %NWMF_FIRST_USERINITED) = %NWMF_FIRST_USERINITED AND _
         (dwFlags AND %NWMF_USERINITED) = %NWMF_USERINITED THEN
         vURL = strURL
         pIWebBrowser2.Navigate2 vURL
         ' Flag that indicates that this event has been fired.
         bNewWindow3 = %TRUE
      ELSE
         ' Popup blocker.
         LOCAL hr AS LONG
         hr = MessageBox(BYVAL hWnd, "Do you want to activate the popup window?" & $CRLF & strURL, _
              "Popup blocked", %MB_YESNOCANCEL OR %MB_ICONQUESTION OR %MB_APPLMODAL)
         IF hr = %IDYES THEN pIWebBrowser2.Navigate2 vURL
      END IF

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD SetPhishingFilterStatus <282> ( _
     BYVAL PhishingFilterStatus AS LONG _               ' __in long PhishingFilterStatus
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD WindowStateChanged <283> ( _
     BYVAL dwWindowStateFlags AS DWORD _                ' __in unsigned long dwWindowStateFlags
   , BYVAL dwValidFlagsMask AS DWORD _                  ' __in unsigned long dwValidFlagsMask
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

END INTERFACE

END CLASS
